Package: dropbead
Type: Package
Title: dropbead
Version: 0.3.1
Date: 2015-11-14
Author: Nikos Karaiskos
Maintainer: Nikos Karaiskos <nikolaos.karaiskos@mdc-berlin.de>
Depends:
    ggplot2,
    grid,
    RColorBrewer,
    gridExtra,
    gplots,
    plyr
Suggests:
    data.table,
    Rsamtools
Description: Basic Exploration and Analysis of Drop-seq Data
License: GNU GPL3
Collate:
    Tools.R
    DGEMatrix.R
    SingleSpeciesSample.R
    MixedSpeciesSample.R
    plottingMethods.R
LazyData: TRUE
NeedsCompilation: no
Packaged: 2015-11-14 09:59:18 UTC; root
RoxygenNote: 6.0.1

# Dropbead: Basic Exploration and Analysis of Drop-seq Data

## About
This `R` package is created and maintained by Nikos Karaiskos.
It offers a quick and straightfoward way to explore and perform
basic analysis of single cell sequencing data coming from droplet
sequencing. It has been particularly tailored for Drop-seq.

Dropbead accompanies the following publication and was used to
generate all figures appearing in the manuscript prior clustering.


*Cell fixation and preservation for droplet-based single-cell transcriptomics*, <br />
[BMC Biology 2017 15:44](https://bmcbiol.biomedcentral.com/articles/10.1186/s12915-017-0383-5),
[bioRxiv](http://biorxiv.org/content/biorxiv/early/2017/04/13/099473.full.pdf), 99473 (2017)
doi: https://doi.org/10.1101/099473 

J. Alles<sup>#</sup>, N. Karaiskos<sup>#</sup>, S. Praktiknjo<sup>#</sup>, S. Grosswendt, P. Wahle, P.-L. Ruffault,
S. Ayoub, L. Schreyer, A. Boltengagen, C. Birchmeier, R. Zinzen, C. Kocks<sup>&</sup> and N. Rajewsky<sup>&</sup>

<sup>#</sup> Contributed equally <br />
<sup>&</sup> Corresponding authors: [C. Kocks](mailto:christine.kocks@mdc-berlin.de), [N. Rajewsky](mailto:rajewsky@mdc-berlin.de)

[Contact the author](mailto:nikolaos.karaiskos@mdc-berlin.de) in case you've found a bug. 
Feel free to cite the package in case you've used it.

## Installation
The easiest way to install `dropbead` is through `devtools`

```
library(devtools)
install_github("rajewsky-lab/dropbead")
```
## Tutorial
A first walkthrough is found in the tutorial. As the file's size is currently 
too big for Github, to view the tutorial click on the `.html` file, then on the
`raw` format and save it locally. You can then view the tutorial with an
ordinary web browser.

#' Merge multiple samples into a big DGE matrix
#'
#' Merge the DGEs of multiple samples into a big one that can be used for
#' further analysis.
#'
#' @param object A \code{list} of DGEs.
#' @return A \code{data.frame} containing all DGEs merged.
setGeneric("mergeMultipleDGEs",
           function(object) {standardGeneric("mergeMultipleDGEs")})
setMethod("mergeMultipleDGEs",
          "list",
          function(object) {
            list.of.dge <- list()

            for (sample in 1:length(object)) {
              list.of.dge[[sample]] <- cbind(object[[sample]]@dge,
                                             "genes"=as.character(object[[sample]]@genes))
            }

            merged.df <- Reduce(function(...) merge(..., by="genes", all=T),
                                list.of.dge)
            rownames(merged.df) <- merged.df[, 1]
            merged.df <- merged.df[, 2:dim(merged.df)[2]]
            merged.df[is.na(merged.df)] <- 0
            merged.df <- merged.df[order(rownames(merged.df)), ]
            return (merged.df)
          })

#' Estimate the cell number
#'
#' Estimate the number of STAMPS that are present in the data (see Drop-seq
#' computational cookbook for further details).
#'
#' @param object A vector containing the reads per cell as given by the Drop-seq
#' pipeline (BAMTagHistogram).
#' @param max.cells The number of cells to consider as an upper bound and to
#' compute the inflection point (default is 15000).
setGeneric("estimateCellNumber",
           function(object, max.cells=15000) {
           standardGeneric("estimateCellNumber")
           })
setMethod("estimateCellNumber",
          "numeric",
          function(object, max.cells) {
             xdata <- (1:max.cells)/max.cells
             cs <- cumsum(object[1:max.cells]/sum(object[1:max.cells]))
             m <- (cs[max.cells] - cs[1]) / (max.cells - xdata[1])
             dists <- sapply(1:max.cells, function(cell) sin(atan(m)) * abs(cs[cell]-xdata[cell]))
             return (which.max(dists))
           })

#' Extract statistics from mapped reads.
#'
#' Extract statistics from mapped reads, such as total number of reads,
#' uniquely mapped reaqds, percentages of intronic/intergenic etc. The function
#' makes use of the R package Rsamtools (part of Bioconductor).
#'
#' @param object A string describing the exact location of the BAM file for the
#' sample under consideration.
#' @param yieldSize Large BAM files are processed in batches because of memory
#' issues. The parameter \code{yieldSize} controls the batch size. Default value: 10^6.
#' @param sample.name A string describing the sample.
#' @return A \code{data.frame} containing the computed statistics.
setGeneric("extractReadStatistics",
           function(object, yieldSize=10^6, sample.name=NULL) {
             standardGeneric("extractReadStatistics")
           })
setMethod("extractReadStatistics",
          "character",
          function(object, yieldSize, sample.name) {
            bam <- scanBam(BamFile(object), yieldSize=yieldSize,
                           param=ScanBamParam(
                             what='mapq',
                             tag=c('XF', 'GE', 'XC')
                           ))[[1]]

            non.ge.types <- table(bam$tag$XF[which(bam$mapq == 255 & is.na(bam$tag$GE))])

            df <- data.frame('total_reads'=round(length(bam$mapq)/10^6, 1),
                             'uniq_mapped'=round(sum(bam$mapq == 255, na.rm = T)/10^6, 1),
                             'intronic'=round(non.ge.types['INTRONIC']/10^6, 1),
                             'intergenic'=round(non.ge.types['INTERGENIC']/10^6, 1),
                             'coding'=round(non.ge.types['CODING']/10^6, 1),
                             'UTR'=round(non.ge.types['UTR']/10^6, 1),
                             'total_barcodes'=round(length(unique(bam$tag$XC[which(bam$mapq == 255)]))/10^6, 1))
            rownames(df) <- sample.name
            return (df)
          })

#' Extract downstream statistics
#'
#' Extract downstream basic statistics such as cell number, median numger of reads,
#' genes, UMIs per cell. The \code{data.table} package is used for fast reading
#' of the DGE matrices.
#'
#' @param object The exact location of the folder containing the analyzed data.
#' @param dge.name The file containing the DGE. If none is provided, the function assumes
#' that DGE is stored under the name \code{dge.txt.gz}.
#' @param reads.by.cell The \code{data.frame} containing the reads per cell. If none is
#' provided, the function tries to read the file \code{out_readcounts.txt.gz}.
#' @param min.umi The minimum number of UMIs to keep a cell and not discard it.
#' @param read.stats A \code{data.frame} containing read statistics, as it is produced
#' by the function \code{extractReadStatistics}.
setGeneric("extractDownstreamStatistics",
           function(object, dge.name=NULL, reads.by.cell=NULL, min.umi=250, read.stats=NULL) {
             standardGeneric("extractDownstreamStatistics")
           })
setMethod("extractDownstreamStatistics",
          "character",
          function(object, dge.name, reads.by.cell, min.umi, read.stats) {
            if (is.null(dge.name)) {
              dge <- data.frame(fread(paste0('zcat < ', object, 'dge.txt.gz')), row.names = 1)
            }
            else {
              dge <- data.frame(fread(paste0('zcat < ', object, dge.name)), row.names = 1)
            }
            if (is.null(reads.by.cell)) {
              reads.cell <- data.frame(fread(paste0('zcat < ', object, 'out_readcounts.txt.gz')))
            }
            else {
              reads.cell <- data.frame(fread(paste0('zcat < ', object, reads.by.cell)))
            }

            dge <- dge[, names(dge)[which(colSums(dge) >= min.umi)]]
            reads.cell <- reads.cell[reads.cell[, 2] %in% names(dge)[which(colSums(dge) >= min.umi)], ]

            df = data.frame('cells'=dim(dge)[2],
                            'reads'=round(median(reads.cell[, 1])),
                            'genes'=round(median(colSums(dge > 0))),
                            'umis'=round(median(colSums(dge))),
                            'sum.umi'=round(sum(dge)/10^6, 1),
                            'PCR'=round(median(reads.cell[, 1]/colSums(dge)), 1))
            if (!is.null(read.stats)){
              df$PCR <- round(median((reads.cell[, 1]*(1-sum(read.stats[, 3:6])/read.stats[, 2]))/colSums(dge)), 1)
            }
            return (df)
          })

SingleSpeciesSample <- setClass(Class = "SingleSpeciesSample",
                                slots = c(species1 = "character",
                                          cells = "vector",
                                          genes = "vector",
                                          dge = "data.frame"))

setMethod("initialize",
          "SingleSpeciesSample",
          function (.Object, species1 = "", cells = c(), genes = c(), dge = data.frame()) {
            .Object@species1 = species1
            .Object@cells = names(dge)
            .Object@genes = rownames(dge)
            .Object@dge = dge
            .Object
          })

#' Compute genes per cell
#'
#' Computes the number of genes that a cell expresses.
#'
#' @param object A \code{SingleSpeciesSample}.
#' @param min.umis The minimum number of UMIs to consider the gene as expressed (default is 1).
#' @return A \code{data.frame} with cells, gene counts and species.
setGeneric("computeGenesPerCell",
           function(object, min.umis=1, ...) {standardGeneric("computeGenesPerCell")})
setMethod("computeGenesPerCell",
          "SingleSpeciesSample",
          function(object, min.umis) {
            genes <- data.frame("cells" = names(colSums(object@dge >= min.umis)),
                                "counts" = as.numeric(colSums(object@dge >= min.umis)),
                                "species" = object@species1)
            return (genes)
          })

#' Compute transcripts per cell
#'
#' Computes the number of transcripts (UMIs) that a cell contains.
#'
#' @param object A Single species sample.
#' @return A \code{data.frame} with cells, transcript counts and species.
setGeneric("computeTranscriptsPerCell",
           function(object, ...) {standardGeneric("computeTranscriptsPerCell")})
setMethod("computeTranscriptsPerCell",
          "SingleSpeciesSample",
          function(object) {
            transcripts <- data.frame("cells" = object@cells,
                                      "counts" = as.numeric(colSums(object@dge)),
                                      "species" = object@species1)
            return (transcripts)
          })

setMethod("removeCells",
          "SingleSpeciesSample",
          function(object, cells) {
            return (new("SingleSpeciesSample", species1=object@species1,
                        dge=removeCells(object@dge, cells)))
          })

setMethod("removeLowQualityCells",
          "SingleSpeciesSample",
          function(object, min.genes) {
            return (new("SingleSpeciesSample", species1=object@species1,
                        dge=removeLowQualityCells(object@dge, min.genes)))
          })

setMethod("keepBestCells",
          "SingleSpeciesSample",
          function(object, num.cells, min.num.trans) {
            return (new("SingleSpeciesSample", species1=object@species1,
                        dge=keepBestCells(object@dge, num.cells, min.num.trans)))
          })

setMethod("removeLowQualityGenes",
          "SingleSpeciesSample",
          function(object, min.cells) {
            return (new("SingleSpeciesSample", species1=object@species1,
                        dge=removeLowQualityGenes(object@dge, min.cells)))
          })

setMethod("geneExpressionMean",
          "SingleSpeciesSample",
          function(object) {
            return (geneExpressionMean(object@dge))
          })

setMethod("geneExpressionDispersion",
          "SingleSpeciesSample",
          function(object) {
            return (geneExpressionDispersion(object@dge))
          })

#' List cells that are candidates for collapsing.
#'
#' Identify and list cells which share 11 bases in their barcodes and only the last
#' one is different (usually being N, as a result of the DetectBeadSynthesisErrors
#' tool). The cells are marked as candidates if and only if they're classified
#' as belonging to the same species.
#'
#' @param object A \code{SingleSpeciesSample} object.
#' @return A list of pairs od candidate cells marked for collapsing.
setGeneric("listCellsToCollapse",
           function(object, ...) {
             standardGeneric("listCellsToCollapse")
           })
setMethod("listCellsToCollapse",
          "SingleSpeciesSample",
          function (object) {
            theListOfCellPairs <- list()
            cells <- sort(object@cells)
            for (cell in 1:(length(cells)-1)) {
              if (substr(cells[cell], 1, 11) == substr(cells[cell+1], 1, 11)) {
                if (substr(cells[cell], nchar(cells[cell]), nchar(cells[cell])) == "N" |
                    substr(cells[cell+1], nchar(cells[cell+1]), nchar(cells[cell+1])) == "N") {
                  theListOfCellPairs <- c(theListOfCellPairs, list(c(cells[cell], cells[cell+1])))
                }
              }
            }
            return(theListOfCellPairs)
          })

#' Collapse cells by barcodes similarity
#'
#' Collapse cells which share 11 bases in their barcodes and only the last
#' one is different (usually being N, as a result of the DetectBeadSynthesisErrors
#' tool). The cells are marked as candidates if and only if they're classified
#' as belonging to the same species.
#'
#' @param object A \code{SingleSpeciesSample} object.
#' @return A modified \code{SingleSpeciesSample} object.
setGeneric("collapseCellsByBarcode",
           function(object, ...) {
             standardGeneric("collapseCellsByBarcode")
           })
setMethod("collapseCellsByBarcode",
          "SingleSpeciesSample",
          function(object) {
            listOfCells <- listCellsToCollapse(object)
            if (length(listOfCells) == 0) {
              return(object)
            }

            for (index in 1:length(listOfCells)) {
              object@dge <- cbind(object@dge, rowSums(object@dge[, listOfCells[[index]]]))
            }
            object@dge <- object@dge[, !names(object@dge) %in% unlist(listOfCells)]

            names(object@dge)[(length(names(object@dge)) - length(listOfCells)
                               + 1):length(names(object@dge))] <- unlist(listOfCells)[seq(1, length(unlist(listOfCells)), 2)]
            object@cells <- names(object@dge)
            return (object)
          })

#' Compare gene expression levels between two single species samples
#'
#' Computes the averaged sums of the gene expression levels between two
#' samples, as well as their correlation.
#'
#' @param object1 A \code{SingleSpeciesSample} object.
#' @param object2 A \code{SingleSpeciesSample} object.
#' @param name1 The name of the first sample.
#' @param name2 The name of the second sample.
#' @param method The method for computing the correlation.
#' @return A plot comparing the gene expression levels.
setGeneric("compareGeneExpressionLevels",
           function(object1, object2, name1="sample1", name2="sample2",
                    col="steelblue", method="pearson", ...) {
             standardGeneric("compareGeneExpressionLevels")
           })
setMethod("compareGeneExpressionLevels",
          "SingleSpeciesSample",
          function(object1, object2, name1, name2, col, method) {
            common.genes <- intersect(object1@genes, object2@genes)

            object1 <- object1@dge[common.genes, ]
            object2 <- object2@dge[common.genes, ]

            big.df <- data.frame("genes" = common.genes,
                                 "sample1" = log2(as.numeric(rowSums(object1))+1),
                                 "sample2" = log2(as.numeric(rowSums(object2))+1))

            cor <- signif(cor(big.df$sample1, big.df$sample2, method=method), 2)

            comp.plot <- (ggplot(data = big.df, aes(x = sample1, y = sample2))
                          + ggtitle(paste0("R= ", cor))
                          + xlab(name1) + ylab(name2)
                          + geom_point(col=col, alpha=0.5, size=2)
                          + scale_y_continuous(expand = c(0.02, 0.02))
                          + scale_x_continuous(expand = c(0.02, 0.02))
                          + theme_minimal() + plotCommonGrid + plotCommonTheme
                          + theme(axis.ticks.y = element_blank()))

            return (comp.plot)
          })

setMethod("computeCorrelationSingleCellsVersusBulk",
          "SingleSpeciesSample",
          function(single.cells, bulk.data, method) {
            corr.df <- computeCorrelationSingleCellsVersusBulk(single.cells@dge,
                                                               bulk.data, method)
            return (list(corr.df[[1]], corr.df[[2]]))
          })

setMethod("computeCorrelationCellToCellVersusBulk",
          "SingleSpeciesSample",
          function(single.cells, bulk.data, measure, method) {
            return (computeCorrelationCellToCellVersusBulk(single.cells@dge,
                                                           bulk.data, measure, method))
          })

setMethod("compareSingleCellsAgainstBulk",
          "SingleSpeciesSample",
          function(single.cells, bulk.data, method, ylab, col) {
            return (compareSingleCellsAgainstBulk(single.cells@dge, bulk.data,
                                                  method, ylab, col))
            })

setMethod("computeCellGeneFilteringFromBulk",
          "SingleSpeciesSample",
          function(single.cells, bulk.data, log.space, method,
                   min.cells, max.cells, iteration.steps) {
            computeCellGeneFilteringFromBulk(single.cells@dge, bulk.data, log.space,
                                             method, min.cells, max.cells, iteration.steps)
            })

#' Computes mitochondrial percentage
#'
#' Computes the percentageof UMIs coming from mitochondrial encoded RNA. For human,
#' mouse and melanogaster samples the mitochondrial prefix is hard-coded as \code{MT-},
#' \code{mt-} and \code{mt:} respectively. An alternative prefix can be also provided.
#'
#' @param object A \code{SingleSpeciesSample} object.
#' @param prefix The prefix of mitochondrial genes.
#' @return The percentage of mitochondrial encoded RNA UMIs.
setGeneric("computeMitochondrialPercentage",
           function(object, prefix=NULL) {
             standardGeneric("computeMitochondrialPercentage")
           })
setMethod("computeMitochondrialPercentage",
          "SingleSpeciesSample",
          function(object, prefix) {
            if (is.null(prefix)) {
              if (object@species1 == "human") {
                mt.genes <- object@genes[grep('^MT-', object@genes)]
              }
              else if (object@species1 == "mouse") {
                mt.genes <- object@genes[grep('^mt-', object@genes)]
              }
              else if (object@species1 == "melanogaster") {
                mt.genes <- object@genes[grep('^mt:', object@genes)]
              }
            }
            else {
              mt.genes <- object@genes[grep(prefix, object@genes)]
            }
            return(100*colSums(object@dge[mt.genes, ])/colSums(object@dge))
          })

#' Cell cycle assignment
#'
#' Assigns the cells into the 5 cell cycle phases, following the algorithm described
#' in Macosko et al. 2015. The table of genes is also taken from Macosko et al. 2015.
#'
#' @param object A human or mouse \code{SingleSpeciesSample}.
#' @param gene.file The excel sheet containing the cell cycle phase specific gene
#' markers. Taken from Macosko et al. 2015.
#' @return A \code{data.frame} with cell cycle phase scores for every cell.
setGeneric("assignCellCyclePhases",
           function(object, gene.file="~/Desktop/cell_cycle_genes.xlsx",
                    do.plot=T, ...) {
             standardGeneric("assignCellCyclePhases")
           })
setMethod("assignCellCyclePhases",
          "SingleSpeciesSample",
          function(object, gene.file, do.plot) {
            require(xlsx)
            file.ext = gsub(".*\\.(.*)$","\\1", gene.file)

            if (object@species1 == "human") {
              cc_genes <- read.xlsx(gene.file, sheetIndex = 2, stringsAsFactors = F)
              }

            if (object@species1 == "mouse") {
              cc_genes <- read.xlsx(gene.file, sheetIndex = 3, stringsAsFactors = F)
              }

            g.g1s <- gsub(" ", "", cc_genes$G1.S)
            g.g1s <- g.g1s[!is.na(g.g1s)]
            g.s <- gsub(" ", "", cc_genes$S)
            g.s <- g.s[!is.na(g.s)]
            g.g2m <- gsub(" ", "", cc_genes$G2.M)
            g.g2m <- g.g2m[!is.na(g.g2m)]
            g.m <- gsub(" ", "", cc_genes$M)
            g.m <- g.m[!is.na(g.m)]
            g.mg1 <- gsub(" ", "", cc_genes$M.G1)
            g.mg1 <- g.mg1[!is.na(g.mg1)]

            phase_score = data.frame("G1.S"=rep(0, length(object@cells)),
                                     "S"=rep(0, length(object@cells)),
                                     "G2.M"=rep(0, length(object@cells)),
                                     "M"=rep(0, length(object@cells)),
                                     "M.G1"=rep(0, length(object@cells)))

            for (i in 1:length(object@cells)) {
              phase_score$G1.S[i] = mean(log(object@dge[g.g1s, i]+1, 2), na.rm=T)
              phase_score$S[i] = mean(log(object@dge[g.s, i]+1, 2), na.rm=T)
              phase_score$G2.M[i] = mean(log(object@dge[g.g2m, i]+1, 2), na.rm=T)
              phase_score$M[i] = mean(log(object@dge[g.m, i]+1, 2), na.rm=T)
              phase_score$M.G1[i] = mean(log(object@dge[g.mg1, i]+1, 2), na.rm=T)
            }

            phase_score_norm <- data.frame(apply(phase_score, 2, scale))
            phase_score_norm2 <- data.frame(t(apply(phase_score_norm, 1, scale)))
            names(phase_score_norm2) <- names(phase_score_norm)
            phases <- apply(phase_score_norm2, 1, which.max)

            df1 <- phase_score_norm2[phases == 1, ]
            df1 <- round(df1[order(df1$G1.S, decreasing = T), ], 2)
            df1 <- df1[order(df1$G1.S, df1$S, df1$G2.M, df1$M, df1$M.G1, decreasing = T), ]

            df2 <- phase_score_norm2[phases == 2, ]
            df2 <- round(df2[order(df2$S, decreasing = T), ], 2)
            df2 <- df2[order(df2$S, df2$G1.S, df2$G2.M, df2$M, df2$M.G1, decreasing = T), ]

            df3 <- phase_score_norm2[phases == 3, ]
            df3 <- round(df3[order(df3$G2.M, decreasing = T), ], 2)
            df3 <- df3[order(df3$G2.M,  df3$M, df3$S, df3$M.G1, df3$G1.S, decreasing = T), ]

            df4 <- phase_score_norm2[phases == 4, ]
            df4 <- round(df4[order(df4$M, decreasing = T), ], 2)
            df4 <- df4[order(df4$M, df4$M.G1, df4$G2.M, df4$S, df4$G1.S, decreasing = T), ]

            df5 <- phase_score_norm2[phases == 5, ]
            df5 <- round(df5[order(df5$M.G1, decreasing = T), ], 2)
            df5 <- df5[order(df5$M.G1, df5$G1.S, df5$G2.M, df5$S, df5$M,  decreasing = T), ]

            heatmap_palette <- colorRampPalette(c("#3794bf", "#FFFFFF", "#cc4140"))
            if (do.plot) {
              heatmap.2(as.matrix(t(rbind(df1, df2, df3, df4, df5))), trace='none', Rowv=F, Colv=F,
                        dendrogram='none', labCol=F, col=heatmap_palette(10))
            }

            return(rbind(df1, df2, df3, df4, df5))
          })

# Functions applied directly on the DGE matrix, represented by a data.frame.

#' Remove cells by barcode
#'
#' Removes the provided cells from the sample.
#'
#' @param object A \code{data.frame} representing the DGE.
#' @param cells A character vector of cell barcodes to remove.
#' @return The processed \code{data.frame} is returned.
setGeneric("removeCells",
           function(object, cells) {standardGeneric("removeCells")})
setMethod("removeCells",
          "data.frame",
          function(object, cells) {
            return (object[, !(names(object) %in% cells)])
          })

#' Filter out low quality cells
#'
#' Removes cells expressing less than a minimum of genes (default value is 1000).
#'
#' @param object A \code{data.frame} representing DGE.
#' @param n The minimum number of genes required.
#' @return A \code{data.frame} without the low quality cells.
setGeneric("removeLowQualityCells",
           function(object, min.genes=1000, ...) {standardGeneric("removeLowQualityCells")})
setMethod("removeLowQualityCells",
          "data.frame",
          function(object, min.genes) {
            return (object[, names(object)[colSums(object != 0) >= min.genes]])
          })

#' Keep best cells according to a criterion
#'
#' Subsets the sample by keeping the top n cells, or the cells with a minimum number
#' of UMIs.
#'
#' @param object A \code{data.frame} representing the DGE.
#' @param num.cells The number of cells to keep, ordered by total number of UMIs.
#' @param min.num.trans Keep only cells with at least this number of UMIs.
#' @return The processed object.
setGeneric("keepBestCells",
           function(object, num.cells, min.num.trans=NULL) {standardGeneric("keepBestCells")})
setMethod("keepBestCells",
          "data.frame",
          function(object, num.cells, min.num.trans) {
            if (!is.null(min.num.trans)) {
              tdf <- object[, colSums(object) >= min.num.trans, drop=F]
              return (tdf[rowSums(tdf) > 0, ])
            }
            else {
              tdf <- object[, head(order(colSums(object), decreasing=T), num.cells), drop=F]
              return (tdf[rowSums(tdf) > 0, ])
            }
          })

#' Filter out low quality genes
#'
#' Removes genes which are expressed in less than a minimum number of cells
#' (default is 3).
#'
#' @param object A \code{data.frame} representing DGE.
#' @param n The minimum number of cells.
#' @return A \code{data.frame} without the low quality genes.
setGeneric("removeLowQualityGenes",
           function(object, min.cells=3) {standardGeneric("removeLowQualityGenes")})
setMethod("removeLowQualityGenes",
          "data.frame",
          function(object, min.cells) {
            return (object[rownames(object) %in% rownames(object)[rowSums(object != 0) > min.cells], ])
          })

#' Compute the average expression of each gene across all cells.
#'
#' @param object A \code{data.frame} representing DGE.
#' @return A vector of mean expression values for each gene. Computation in log space.
setGeneric("geneExpressionMean",
           function (object) {standardGeneric("geneExpressionMean")})
setMethod("geneExpressionMean",
          "data.frame",
          function(object) {
            return (log(apply(object, 1, mean), 2))
          })

#' Compute the sum of transcript counts of each gene across all cells.
#'
#' @param object A \code{data.frame} representing DGE.
#' @return A vector of the logarithm of the sum of all UMI values for each gene.
#' A pseudocount is added to avoid infinities.
setGeneric("geneExpressionSumUMI",
           function (object) {standardGeneric("geneExpressionSumUMI")})
setMethod("geneExpressionSumUMI",
          "data.frame",
          function(object) {
            return (log2(rowSums(object)+1))
          })

#' Compute the dispersion of each gene across all cells.
#'
#' @param object A \code{data.frame} representing DGE.
#' @return A vector of variance/mean expression values for each gene. Computation in log space.
setGeneric("geneExpressionDispersion",
           function (object) {standardGeneric("geneExpressionDispersion")})
setMethod("geneExpressionDispersion",
          "data.frame",
          function(object) {
            return (log(apply(object, 1, var)/apply(object, 1, mean), 2))
          })

#' Compare single cell sample against bulk data
#'
#' Computes correlation of gene expression measurements between a single cell
#' sample and bulk data.
#'
#' @param single.cells The single cell object (could be a DGE or a
#' \code{SingleSpeciesSample} object).
#' @param bulk.data The bulk data formed as a \code{data.frame} with genes as
#' rownames and RPKM values as the first column.
#' @param method The method to compute the correlation (default is Pearson).
#' @return A list of length 2. First item is the correlation and second is the
#' \code{data.frame}.
setGeneric("computeCorrelationSingleCellsVersusBulk",
           function(single.cells, bulk.data, method="pearson") {
             standardGeneric("computeCorrelationSingleCellsVersusBulk")
           })
setMethod("computeCorrelationSingleCellsVersusBulk",
          "data.frame",
          function(single.cells, bulk.data, method) {
            common.genes <- intersect(rownames(single.cells), rownames(bulk.data))
            single.cells <- single.cells[common.genes, ]
            single.cells <- max(colSums(single.cells)) * sweep(single.cells, MARGIN=2,
                                                               FUN='/', colSums(single.cells))
            single.cells <- log2(rowSums(single.cells) + 1)

            bulk <- bulk.data[common.genes, ]

            df = data.frame("sc"=single.cells, "bulk"=bulk)
            correlation = signif(cor(single.cells, bulk, method=method), 2)

            return (list(correlation, df))
          })

setGeneric("computeCorrelationCellToCellVersusBulk",
           function(single.cells, bulk.data, measure="umi", method="pearson") {
             standardGeneric("computeCorrelationCellToCellVersusBulk")
           })
setMethod("computeCorrelationCellToCellVersusBulk",
          "data.frame",
          function(single.cells, bulk.data, measure, method) {
            vectorOfCorrelations <- c()
            for (cell in names(single.cells)) {
              vectorOfCorrelations <- c(vectorOfCorrelations,
                                        computeCorrelationSingleCellsVersusBulk(single.cells[, cell, drop=F],
                                                                                bulk.data)[[1]])
            }
            return (vectorOfCorrelations)
          })

#' Compare gene expression between single cell sample and bulk
#'
#' Compares the gene expression measurements from single cell data against bulk data.
#'
#' @param single.cells A \code{data.frame} containing genes as rownames and columns as cells.
#' @param bulk.data A \code{data.frame} containing genes as rownames and a single column
#' with transcript counts.
#' @param log.space If True (default value) then the average of single cells data is
#' performed in log space.
#' @param ylab Label of the single cell sample.
#' @param col The color of the scatterplot points.
#' @return A scatterplot comparing the gene expression levels and with the correlation
#' among the samples computed.
setGeneric("compareSingleCellsAgainstBulk",
           function(single.cells, bulk.data, method="pearson",
                    ylab="single cell sample", col="steelblue", ...) {
             standardGeneric("compareSingleCellsAgainstBulk")
           })
setMethod("compareSingleCellsAgainstBulk",
          "data.frame",
          function(single.cells, bulk.data, method, ylab, col) {
            corr.df <- computeCorrelationSingleCellsVersusBulk(single.cells, bulk.data, method)

            corr = corr.df[[1]]
            df = corr.df[[2]]

            g <- (ggplot(df, aes(x=bulk, y=sc)) + geom_point(col=col, alpha=0.5, size = 3)
                  + theme_minimal() +  plotCommonTheme + xlab("log2(RPKM+1) [mRNA-seq]")
                  + ylab(paste0("log2(ATPM+1) [", ylab, "]"))
                  + ggtitle(paste0("R= ", corr)) + scale_x_continuous(expand=c(0.01, 0.02))
                  + theme(plot.title = element_text(size=22),
                          text=element_text(size=24),
                          plot.margin = unit(c(1, 1 , 0.5, 0.5), "cm"),
                          panel.border = element_rect(colour = "black", fill=NA, size=1),
                          panel.grid.major = element_blank()) )
            return (g)
          })

setGeneric("computeCellGeneFilteringFromBulk",
           function(single.cells, bulk.data, log.space=T, method="pearson",
                    min.cells=500, max.cells=2000, iteration.steps=50, do.plot=F) {
             standardGeneric("computeCellGeneFilteringFromBulk")
           })
setMethod("computeCellGeneFilteringFromBulk",
          "data.frame",
          function(single.cells, bulk.data, log.space, method,
                   min.cells, max.cells, iteration.steps, do.plot) {
            cor.list = c()
            cell.list = c()

            for (cells in seq(min.cells, max.cells, iteration.steps)) {
              temp.sample <- removeLowQualityGenes(removeLowQualityCells(single.cells, cells))
              temp.cor = computeCorrelationSingleCellsVersusBulk(temp.sample, bulk.data)[[1]]
              cor.list = c(cor.list, temp.cor)
              cell.list = c(cell.list, dim(temp.sample)[2])
              print (c(temp.cor, cells))
            }
            if (do.plot) {
              df <- data.frame("min.genes"=seq(min.cells, max.cells, iteration.steps),
                               "correlation"=cor.list,
                               "cells"=cell.list)
              g1 <- (ggplot(df, aes(x=min.genes, y=correlation)) + geom_point(size=3, col="steelblue")
                     + theme_minimal() + plotCommonGrid + plotCommonTheme)
              g2 <- (ggplot(df, aes(x=min.genes, y=cells)) + geom_point(size=3, col="steelblue")
                     + theme_minimal() + plotCommonGrid + plotCommonTheme)
              return(grid.arrange(g1, g2, ncol=2))
            }
          })

plotCommonTheme <- theme(text = element_text(size = 24),
                         axis.title.y = element_text(vjust = 1.2),
                         axis.title.x = element_text(vjust = 0))

plotCommonGrid <- theme(panel.grid.major.x = element_blank(),
                        panel.grid.major.y = element_line(colour = "grey50", size = 0.1),
                        panel.grid.minor = element_blank())

#' Violin plot of an attribute
#'
#' @param object A \code{data.frame} such as the outputs of \code{computeGenesPerCell}
#' and \code{computeTranscriptsPerCell}.
#' @param attribute A \code{charracter string} describing the attribute.
setGeneric(name = "plotViolin",
           def = function(object, attribute="ATTRIBUTE MISSING") {standardGeneric("plotViolin")})
setMethod(f = "plotViolin",
          signature = "data.frame",
          function(object, attribute) {
            v <- (ggplot(object, aes_string(x = names(object)[3], y = names(object)[2],
                                            fill = names(object)[3]))
                  + geom_violin(size=1)
                  + scale_fill_grey(start = 0.9, end = 0.5)
                  + scale_y_continuous(limits = c(0, max(object[, 2])))
                  + ylab(paste("Number of", attribute)) + xlab("")
                  + geom_boxplot(width = 0.3, outlier.size = 0.5) + guides(fill = F)
                  + theme_minimal() + plotCommonTheme
                  + theme(panel.border = element_rect(colour = "black", fill=NA, size=1),
                          panel.grid.major = element_blank()))
            return (v)
          })

#' Histogram plot of an attribute
#'
#' @param object A \code{data.frame} such as the outputs of \code{computeGenesPerCell}
#' and \code{computeTranscriptsPerCell}.
#' @param attribute A \code{charracter string} describing the attribute.
setGeneric(name = "plotHistogram",
           def = function(object, attribute="ATTRIBUTE MISSING") {standardGeneric("plotHistogram")})
setMethod(f = "plotHistogram",
          signature = "data.frame",
          function(object, attribute) {
            plotLocalCommon <- (theme_minimal() + plotCommonGrid + plotCommonTheme
                                + theme(axis.text.y = element_blank(), axis.ticks = element_blank()))

            species1 = names(table(object$species))[1]
            g.sp1 <- (ggplot(object[object$species == species1, ], aes(counts))
                      + xlab(paste(species1, attribute, "per", species1, "cell")) + ylab("")
                      + geom_histogram(aes(y = ..density..), fill = "steelblue", alpha = 0.8)
                      + geom_density(col = "black", size = 1) + plotLocalCommon)

            if (length(table(object$species)) > 1) {
              species2 = names(table(object$species))[2]
              g.sp2 <- (ggplot(object[object$species == species2, ], aes(counts))
                        + xlab(paste(species2, attribute, "per", species2 , "cell")) + ylab("")
                        + geom_histogram(aes(y = ..density..), fill = "firebrick", alpha = 0.8)
                        + geom_density(col = "black", size = 1) + plotLocalCommon)
              return (grid.arrange(g.sp1, g.sp2, ncol = 2))
            }
            return (g.sp1)
          })

#' Plots the knee plot
#'
#' Plots the cumulative fraction of reads against cell barcodes (in descending
#' number of reads). This way provides a heuristic computation of the number of
#' STAMPS in the sample (see computational cookbook from Macosko et. al. 2015
#' for further details and reasoning).
#'
#' @param object A \code{data.frame} read from out_readcounts.txt.gz
#' @param cutoff The number of cells to take into account (default is 10000).
#' @param draw.knee.point Whether to annotate the knee point or not.
setGeneric("plotCumulativeFractionOfReads",
           function(object, cutoff=10000, draw.knee.point=TRUE) {
             standardGeneric("plotCumulativeFractionOfReads")})
setMethod("plotCumulativeFractionOfReads",
          "data.frame",
          function(object, cutoff, draw.knee.point) {
            df <- data.frame("cum"=cumsum(object[1:cutoff, 1])/max(cumsum(object[1:cutoff, 1])),
                             "cells"=1:cutoff)

            knee.point <- estimateCellNumber(object[1:cutoff, 1], max.cells=cutoff)

            g <- (ggplot(df, aes(cells, cum)) + geom_line(col="steelblue", size=1.25) + theme_minimal()
            + scale_x_continuous(expand=c(0.015, 0))
            + scale_y_continuous(expand = c(0.01, 0)) + ylab("Cumulative fraction of reads")
            + xlab("Cell barcodes (descending number of reads)")
            + theme(text=element_text(size=24),
                    plot.margin = unit(c(1, 1 , 0.5, 0.5), "cm"),
                    panel.border = element_rect(colour = "black", fill=NA, size=1),
                    panel.grid.major = element_blank()))
            if (draw.knee.point) {
              g <- (g + geom_vline(xintercept = knee.point, col='red', size=1)
                    + ggtitle(paste0('Number of STAMPS: ', knee.point))
                    + theme(title = element_text(size=16)))
            }
            return (g)
          })

setGeneric("plotHistogramCorrelations",
           function(object, xlab="", col="steelblue") {
             standardGeneric("plotHistogramCorrelations")})
setMethod("plotHistogramCorrelations",
          "vector",
          function(object, xlab, col) {
            g <- (ggplot(data.frame("correlation"=object), aes(correlation))
                  + geom_histogram(binwidth=0.005, fill=col)
                  + ylab("") + xlab(xlab) + theme_minimal() + plotCommonGrid + plotCommonTheme)
            return (g)
          })

#' Heatmap of the correlation matrix for pairs of cells.
#'
#' @param object A \code{data.frame} representing the DGE matrix.
setGeneric(name = "plotHeatmapCorrelationMatrixDGE",
           def = function(object) {standardGeneric("plotHeatmapCorrelationMatrixDGE")})
setMethod(f = "plotHeatmapCorrelationMatrixDGE",
          signature = "data.frame",
          function(object) {
            heatmap_palette <- colorRampPalette(c("#3794bf", "#FFFFFF", "#df8640"))
            heatmap.2(cor(as.matrix(object)), trace = "none", labRow = F,
                      labCol = F, dendrogram = "row", col=heatmap_palette(20))
          })

#' Plot mitochondrial content
#'
#' Violin plots of mitochondrial content of one or more samples.
#'
#' @param object A list of mitochondrial content percentages, as computed by the
#' \code{ComputeMitochondrialContent} function.
#' @param log_scale Should the y-axis be in the log-scale?
#' @param sample_names The sample names
setGeneric("plotMitochondrialContent",
           function(object, log_scale=TRUE, sample_names=paste0('sample', 1:length(object))) {
             standardGeneric("plotMitochondrialContent")
           })
setMethod("plotMitochondrialContent",
          "list",
          function(object, log_scale, sample_names) {
            object <- lapply(object, as.numeric)
            mtrx <- matrix(data=NA, nrow = max(sapply(object, length)), ncol = length(object))
            df <- data.frame(mtrx)
            names(df) <- sample_names

            for (sample in 1:length(object)) {
              df[1:length(object[[sample]]), sample] <- object[[sample]]
            }

            g <- (ggplot(melt(df), aes(variable, value)) + geom_violin(fill="grey")
                  + ylab("% of cytoplasmic reads") + xlab("") + theme_minimal()
                  + plotCommonTheme + plotCommonGrid
                  + geom_boxplot(width = 0.1, outlier.size = 0.5))
            if (log_scale) {g <- g + scale_y_log10()}
            return (g)
          })

#' Plot separation of species
#'
#' Scatter plot of all cells by transcripts of species (a.k.a. barnyard plot). Species
#' and doublets are separated by different colors.
#'
#' @param object A \code{data.frame} produced by the \code{classifyCellsAndDoublets}
#' function.
setGeneric(name = "plotCellTypes",
           def = function(object) {standardGeneric("plotCellTypes")})
setMethod(f = "plotCellTypes",
          signature = "data.frame",
          function(object) {
            cell.types.plot <- (ggplot(data = object, aes_string(names(object)[2], names(object)[3],
                                                                 col = names(object)[4]))
                                + geom_point(size = 4, alpha = 0.4) + theme_classic()
                                + xlab(paste(names(object)[2], "transcripts (UMIs)"))
                                + ylab(paste(names(object)[3], "transcripts (UMIs)"))
                                + scale_color_manual(values = c("steelblue", "purple", "firebrick", "grey"),
                                                     labels = c(paste0(names(object)[2], " (",
                                                                       table(object$species)[names(object)[2]], ")"),
                                                                paste0("mixed (", table(object$species)['mixed'], ")"),
                                                                paste0(names(object)[3], " (",
                                                                       table(object$species)[names(object)[3]], ")"),
                                                                paste0("low UMIs", " (",
                                                                       table(object$species)['undefined'], ")")))
                                + plotCommonTheme
                                + scale_x_continuous(expand=c(0.015, 0), limits = c(0, max(object[2:3])+2500))
                                + scale_y_continuous(expand=c(0.03, 0), limits = c(0, max(object[2:3])+2500))
                                + guides(col = guide_legend(override.aes = list(alpha=1)))
                                + theme(legend.title = element_blank(),
                                        legend.position = c(0.85, 0.85),
                                        axis.line.x = element_line(colour = "black"),
                                        axis.line.y = element_line(colour = "black"),
                                        plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "cm"),
                                        panel.border = element_rect(colour = "black", fill=NA, size=1)))
            return(cell.types.plot)
          })

library(data.table)
library(dropbead)

# load a DGE to test
d <- data.frame(fread("zcat < /data/rajewsky/home/nkarais/projects/hek3t3/raw/macosko/SpeciesMix_ThousandSTAMPs_50cellspermicroliter/SRR1748411/subset/dge.txt.gz"), row.names = 1)
m <- new("MixedSpeciesSample", species1="human", species2="mouse", dge=d)
sh <- splitMixedSpeciesSampleToSingleSpecies(m, 0.9)[[1]]
sm <- splitMixedSpeciesSampleToSingleSpecies(m, 0.9)[[2]]

do <- data.frame(fread("zcat < /mydaten/projects/hek3t3/data/ds_012_50/dge.txt.gz"), row.names = 1)
mo <- new("MixedSpeciesSample", species1="human", species2="mouse", dge=do)
sho <- splitMixedSpeciesSampleToSingleSpecies(mo, 0.9)[[1]]
smo <- splitMixedSpeciesSampleToSingleSpecies(mo, 0.9)[[2]]

d.hek.50 <- data.frame(fread("zcat < /mydaten/hek3t3fly/Rajewsky/NR_CK_020/ds_009_50/dge.txt.gz"), row.names = 1)
o.50 <- new("MixedSpeciesSample", species1="human", species2="mouse", dge=d.hek.50)

createSamplesForTesting <- function() {
  genes <- c(sample(letters, 25), sample(paste0(letters, letters), 25),
             sample(LETTERS, 25), sample(paste0(LETTERS, LETTERS), 25))
  cells <- c()
  for (i in 1:510) {
    cells <- c(cells, paste(sample(c("A", "C", "G", "T"), 12, replace=T), collapse=""))
  }
  for (m in c(57, 172, 311, 489)) {
    cells[m] <- paste0(substr(cells[m-1], 1, 11), "N")
  }
  dge.human.cells <- data.frame(matrix(0, ncol=240, nrow=50))
  dge.mouse.cells <- data.frame(matrix(0, ncol=260, nrow=50))
  dge.full <- data.frame(matrix(0, ncol=510, nrow=100))
  for (i in 1:10) {
    dge.full[, i] <- round(runif(100, 0, 2*i))
  }
  for (i in 11:240) {
    dge.full[, i] <- c(sample(4, 50, replace = T, prob = c(0.6, .15, .15, .1))-1, sample(i/2, 50, replace = T)-1)
    dge.human.cells[, i-10] <- dge.full[51:100, i]
  }
  for (i in 241:250) {
    dge.full[, i] <- c(sample(4, 50, replace = T, prob = c(0.6, .15, .15, .1))-1, sample(i/2, 50, replace = T)-1)
    dge.human.cells[, i-10] <- dge.full[51:100, i]
  }
  for (i in 251:280) {
    dge.full[, i] <- c(sample((i-240)/2, 50, replace = T)-1, sample(4, 50, replace = T, prob = c(0.6, .15, .15, .1))-1)
    dge.mouse.cells[, i-250] <- dge.full[1:50, i]
  }
  for (i in 281:510) {
    dge.full[, i] <- c(sample((i-240)/2, 50, replace = T)-1, sample(4, 50, replace = T, prob = c(0.6, .15, .15, .1))-1)
    dge.mouse.cells[, i-250] <- dge.full[1:50, i]
  }
  rownames(dge.full) <- genes
  rownames(dge.human.cells) <- genes[51:100]
  rownames(dge.mouse.cells) <- genes[1:50]
  names(dge.full) <- cells
  names(dge.human.cells) <- names(dge.full)[11:250]
  names(dge.mouse.cells) <- names(dge.full)[251:510]

  single.human <- new("SingleSpeciesSample", species1="human", dge=dge.human.cells)
  single.mouse <- new("SingleSpeciesSample", species1="mouse", dge=dge.mouse.cells)
  mixed <- new("MixedSpeciesSample", species1="human", species2="mouse", dge=dge.full)

  return (list(mixed, single.human, single.mouse))
}

testSplittingMixedToSingleSpecies <- function() {
  in.silico.samples <- createSamplesForTesting()
  mixed <- in.silico.samples[[1]]
  single.human <- in.silico.samples[[2]]
  single.mouse <- in.silico.samples[[3]]

  # Test number of cells for each species
  if (!table(classifyCellsAndDoublets(mixed, 0.6, min.trans=0)$species)[[1]] == dim(single.human@dge)[2]) {
    print ("Error! Number of human cells doesn't match.")
  } else {
      print ("Testing number of human cells... Passed")
    }
  if (!table(classifyCellsAndDoublets(mixed, 0.6, min.trans=0)$species)[[3]] == dim(single.mouse@dge)[2]) {
    print ("Error! Number of mouse cells doesn't match.")
  } else {
    print ("Testing number of mouse cells... Passed")
  }
  # Test number of genes per cell per species
  if (sum(computeGenesPerCell(mixed, 0.6, min.reads = 0)[1:240, 'counts'] == computeGenesPerCell(single.human, min.reads = 0)$counts) != 240) {
    print ("Error! The number of genes in human cells don't match")
  } else {
    print ("Testing number of genes in human cells... Passed")
  }
  if (sum(computeGenesPerCell(mixed, 0.6, min.reads=0)[241:500, 'counts'] == computeGenesPerCell(single.mouse, min.reads = 0)$counts) != 260) {
    print ("Error! The number of genes in mouse cells don't match")
  } else {
    print ("Testing number of genes in mouse cells... Passed")
  }
  # Test number of transcripts per cell per species
  if (sum(computeTranscriptsPerCell(mixed, 0.6)[1:240, 'counts'] == computeTranscriptsPerCell(single.human)$counts) != 240) {
    print ("Error! The number of transcripts in human cells don't match")
  } else {
    print ("Testing number of transcripts in human cells... Passed")
  }
  if (sum(computeTranscriptsPerCell(mixed, 0.6)[241:500, 'counts'] == computeTranscriptsPerCell(single.mouse)$counts) != 260) {
    print ("Error! The number of transcripts in mouse cells don't match")
  } else {
    print ("Testing number of transcripts in mouse cells... Passed")
  }
  # Testing collapsing of cells by barcodes
  collapseDf <- classifyCellsAndDoublets(collapseCellsByBarcode(mixed, 0.6), 0.6)
  collapseDfS <- collapseCellsByBarcode(single.human)@cells
  if (sum(collapseDf[collapseDf$species == "human", ]$cell ==  collapseCellsByBarcode(single.human)@cells) == 238) {
    print ("Testing collapsing human cells by barcode... Passed")
  } else {
      print ("Error! Collapsing human cells by barcodes is not the same for single and mixed species.")
  }
  if (sum(collapseDf[collapseDf$species == "mouse", ]$cell ==  collapseCellsByBarcode(single.mouse)@cells) == 258) {
    print ("Testing collapsing mouse cells by barcode... Passed")
  } else {
    print ("Error! Collapsing mouse cells by barcodes is not the same for single and mixed species.")
  }
  }

MixedSpeciesSample <- setClass(Class = "MixedSpeciesSample",
                         slots = c(species2 = "character"),
                         contains = "SingleSpeciesSample"
                         )

setMethod("initialize",
          "MixedSpeciesSample",
          function (.Object, species1="", species2="", cells=c(), genes=c(),
                    dge=data.frame()) {
            .Object@species1 = species1
            .Object@species2 = species2
            .Object@cells = names(dge)
            .Object@genes = rownames(dge)
            .Object@dge = dge
            .Object
          })

#' Split DGE by genes of species
#'
#' Splits the DGE of a \code{MixedSpeciesSample} into two \code{SingleSpeciesSample} DGEs.
#' The splitting is done by the prefixes of the gene names. If no prefixes are provided
#' the defaults are \code{hg_} for human and \code{mm_} for mouse respectively.
#'
#' @param object A \code{MixedSpeciesSample} object.
#' @param prefix1 The prefix of the gene names for species1.
#' @param prefix2 The prefix of the gene names for species2.
#' @return A list of \code{data.frames} corresponding to the genes of the two species.
setGeneric(name = "splitDgeByGenesOfSpecies",
           def = function(object, prefix1=NULL, prefix2=NULL) {
             standardGeneric("splitDgeByGenesOfSpecies")})
setMethod(f = "splitDgeByGenesOfSpecies",
          signature = "MixedSpeciesSample",
          function(object, prefix1, prefix2) {
            if (is.null(prefix1) & is.null(prefix2)) {
              if (object@species1 == "human" & object@species2 == "mouse") {
                object.species1 <- object@dge[grep("hg_", object@genes), ]
                rownames(object.species1) <- gsub("hg_", "", rownames(object.species1))
                object.species2 <- object@dge[grep("mm_", object@genes), ]
                rownames(object.species2) <- gsub("mm_", "", rownames(object.species2))
              }
              if (object@species1 == "melanogaster" & object@species2 == "virilis") {
                object.species2 <- object@dge[grep("Dvir_", object@genes), ]
                object.species1 <- object@dge[setdiff(1:(length(object@genes)),
                                                      grep("Dvir_", object@genes)), ]
              }
            }
            else {
              object.species1 <- object@dge[grep(prefix1, object@genes), ]
              rownames(object.species1) <- gsub(prefix1, "", rownames(object.species1))
              object.species2 <- object@dge[grep(prefix2, object@genes), ]
              rownames(object.species2) <- gsub(prefix2, "", rownames(object.species2))
            }
            return (list(object.species1, object.species2))
          })

#' Classify cells to species
#'
#'
#' Classify the cells to species according to the transcripts they express.
#' The differentiation of species is performed internally and according to
#' the \code{species1} and \code{species2} labels of the sample. If the
#' classificiation is not confident enough, the cell is characterized as doublet.
#'
#' @param object A \code{MixedSpeciesSample} object.
#' @param threshold The threshold which the ratio of transcripts of one species
#' over the other has to surpass in order to succesfully assign a cell to a species.
#' Below that threshold the cell is characterized as a doublet.
#' @param min.trans The minimum number of transcripts (UMIs) required for a cell.
#' @return A \code{data.frame} containing the cell barcodes, the number of transcripts
#' per species and the characterization of the cell.
setGeneric("classifyCellsAndDoublets",
           function(object, threshold=0.9, min.trans=500) {
             standardGeneric("classifyCellsAndDoublets")})
setMethod("classifyCellsAndDoublets",
          "MixedSpeciesSample",
          function(object, threshold, min.trans) {
            object.species1 <- splitDgeByGenesOfSpecies(object)[[1]]
            object.species2 <- splitDgeByGenesOfSpecies(object)[[2]]

            df <- data.frame("cell" = names(object@dge),
                             "s1" = as.vector(colSums(object.species1)),
                             "s2" = as.vector(colSums(object.species2)),
                             "species" = "", stringsAsFactors = F)
            for (i in 1:dim(df)[1]) {
               if (df$s1[i] + df$s2[i] < min.trans) {
                 df$species[i] = "undefined"
                 next
               }
              if (df$s1[i] > df$s2[i] & df$s1[i]/(df$s1[i] + df$s2[i]) > threshold) {
                df$species[i] = object@species1
                next
              }
              if (df$s2[i] > df$s1[i] & df$s2[i]/(df$s1[i] + df$s2[i]) > threshold) {
                df$species[i] = object@species2
                next
                }
              df$species[i] = "mixed"
            }
            names(df) <- c("cell", object@species1, object@species2, "species")

            return (df)
          })

#' Split DGE by genes and cells of species
#'
#' @param object A \code{MixedSpeciesSample} object.
#' @param threshold The threshold which the ratio of transcripts of one species
#' over the other has to surpass in order to succesfully assign a cell to a species.
#' @return A list \code{data.frames} representing the DGEs for each species.
setGeneric("splitDgeByGenesAndCellsOfSpecies",
           function(object, threshold=0.9) {
             standardGeneric("splitDgeByGenesAndCellsOfSpecies")})
setMethod("splitDgeByGenesAndCellsOfSpecies",
          "MixedSpeciesSample",
          function(object, threshold) {
            split.dge <- splitDgeByGenesOfSpecies(object)

            object.species1 <- split.dge[[1]]
            object.species2 <- split.dge[[2]]

            df <- classifyCellsAndDoublets(object, threshold)

            object.species1 <- object.species1[, df[df$species == object@species1, ]$cell]
            object.species2 <- object.species2[, df[df$species == object@species2, ]$cell]

            object.species1 <- object.species1[which(rowSums(object.species1) != 0), ]
            object.species2 <- object.species2[which(rowSums(object.species2) != 0), ]

            return (list(object.species1, object.species2))
          })

#' Separate the mixed species sample into two single species samples
#'
#' @param object A \code{MixedSpeciesSample} object.
#' @param threshold The threshold which the ratio of transcripts of one species
#' over the other has to surpass in order to succesfully assign a cell to a species.
#' @return A list of two \code{SingleSpeciesSample} objects.
setGeneric("splitMixedSpeciesSampleToSingleSpecies",
           function(object, threshold=0.9) {
             standardGeneric("splitMixedSpeciesSampleToSingleSpecies")})
setMethod("splitMixedSpeciesSampleToSingleSpecies",
          "MixedSpeciesSample",
          function(object, threshold) {
            splitted.species <- splitDgeByGenesAndCellsOfSpecies(object, threshold)
            s1 <- new("SingleSpeciesSample",
                      species1 = object@species1,
                      cells = object@cells,
                      genes = rownames(splitted.species[[1]]),
                      dge = splitted.species[[1]])
            s2 <- new("SingleSpeciesSample",
                      species1 = object@species2,
                      cells = object@cells,
                      genes = rownames(splitted.species[[2]]),
                      dge = splitted.species[[2]])
            return (list(s1, s2))
          })

setMethod("computeGenesPerCell",
          "MixedSpeciesSample",
          function(object, min.umis, threshold=0.9) {
            return(rbind.fill(lapply(splitMixedSpeciesSampleToSingleSpecies(object, threshold),
                                     computeGenesPerCell, min.umis=min.umis)))
          })

setMethod("computeTranscriptsPerCell",
          "MixedSpeciesSample",
          function(object, threshold=0.9) {
            return (rbind.fill(lapply(splitMixedSpeciesSampleToSingleSpecies(object, threshold),
                                      computeTranscriptsPerCell)))
          })

setMethod("removeCells",
          "MixedSpeciesSample",
          function(object, cells) {
            return (new("MixedSpeciesSample", species1=object@species1, species2=object@species2,
                        dge=removeCells(object@dge, cells)))
          })

setMethod("removeLowQualityCells",
          "MixedSpeciesSample",
          function(object, min.genes) {
            return (new("MixedSpeciesSample", species1=object@species1, species2=object@species2,
                        dge=removeLowQualityCells(object@dge, min.genes)))
          })

setMethod("keepBestCells",
          "MixedSpeciesSample",
          function(object, num.cells, min.num.trans) {
            return (new("MixedSpeciesSample", species1=object@species1, species2=object@species2,
                        dge=keepBestCells(object@dge, num.cells, min.num.trans)))
          })

setMethod("removeLowQualityGenes",
          "MixedSpeciesSample",
          function(object, min.cells) {
            return (new("MixedSpeciesSample", species1=object@species1, species2=object@species2,
                        dge=removeLowQualityGenes(object@dge, min.cells)))
          })

#' List cells that are candidates for collapsing.
#'
#' Identify and list cells which share 11 bases in their barcodes and only the last
#' one is different. The cells are marked as candidates if and only if they're classified
#' as belonging to the same species.
#' @param A \code{MixedSpeciesSample} object.
setMethod("listCellsToCollapse",
          "MixedSpeciesSample",
          function (object, threshold=0.9) {
            return(unlist(lapply(splitMixedSpeciesSampleToSingleSpecies(object, threshold),
                                 listCellsToCollapse), recursive = F))
          })

setMethod("collapseCellsByBarcode",
          "MixedSpeciesSample",
          function(object, threshold=0.9) {
            listOfCells <- listCellsToCollapse(object, threshold)
            if (length(listOfCells) == 0) {
              return(object)
            }

            for (index in 1:length(listOfCells)) {
              object@dge <- cbind(object@dge, rowSums(object@dge[, listOfCells[[index]]]))
            }
            object@dge <- object@dge[, !names(object@dge) %in% unlist(listOfCells)]

            names(object@dge)[(length(names(object@dge)) - length(listOfCells)
                               + 1):length(names(object@dge))] <- unlist(listOfCells)[seq(1, length(unlist(listOfCells)), 2)]
            object@cells <- names(object@dge)
            return (object)
          })

#' Compare gene expression levels between two mixed species samples
#'
#' @param object1 A \code{MixedSpeciesSample} object.
#' @param object2 A \code{MixedSpeciesSample} object.
#' @param threshold1 The threshold for the firs sample.
#' @param threshold2 The threshold for the second sample.
#' @return A plot comparing the gene expression levels by species.
setMethod("compareGeneExpressionLevels",
          "MixedSpeciesSample",
          function(object1, object2, threshold1, threshold2, name1="sample1", name2="sample2") {
            object1.species1 <- splitDgeByGenesAndCellsOfSpecies(object1, threshold1)[[1]]
            object1.species2 <- splitDgeByGenesAndCellsOfSpecies(object1, threshold1)[[2]]
            object2.species1 <- splitDgeByGenesAndCellsOfSpecies(object2, threshold2)[[1]]
            object2.species2 <- splitDgeByGenesAndCellsOfSpecies(object2, threshold2)[[2]]

            common.genes.species1 <- intersect(row.names(object1.species1), row.names(object2.species1))
            common.genes.species2 <- intersect(row.names(object1.species2), row.names(object2.species2))

            object1.species1 <- object1.species1[row.names(object1.species1) %in% common.genes.species1, ]
            object1.species2 <- object1.species2[row.names(object1.species2) %in% common.genes.species2, ]
            object2.species1 <- object2.species1[row.names(object2.species1) %in% common.genes.species1, ]
            object2.species2 <- object2.species2[row.names(object2.species2) %in% common.genes.species2, ]

            object1.species1 <- max(colSums(object1.species1)) * sweep(object1.species1, MARGIN=2,
                                                                       FUN='/', colSums(object1.species1))
            object1.species2 <- max(colSums(object1.species2)) * sweep(object1.species2, MARGIN=2,
                                                                       FUN='/', colSums(object1.species2))
            object2.species1 <- max(colSums(object2.species1)) * sweep(object2.species1, MARGIN=2,
                                                                       FUN='/', colSums(object2.species1))
            object2.species2 <- max(colSums(object2.species2)) * sweep(object2.species2, MARGIN=2,
                                                                       FUN='/', colSums(object2.species2))

            big.df <- data.frame("genes" = c(common.genes.species1, common.genes.species2),
                                 "sample1" = c(log2(rowSums(object1.species1)+1),
                                               log2(rowSums(object1.species2)+1)),
                                 "sample2" = c(log2(rowSums(object2.species1)+1),
                                               log2(rowSums(object2.species2)+1)),
                                 "species" = c(rep(object1@species1, length(common.genes.species1)),
                                               rep(object1@species2, length(common.genes.species2))))

            cor.species1 <- signif(cor(big.df$sample1[big.df$species == object1@species1],
                                       big.df$sample2[big.df$species == object1@species1],
                                       method="pearson"), 2)

            cor.species2 <- signif(cor(big.df$sample1[big.df$species == object1@species2],
                                       big.df$sample2[big.df$species == object1@species2],
                                       method="pearson"), 2)

            levels(big.df$species) <- c(paste0(object1@species1, " (R=", cor.species1, ")"),
                                        paste0(object1@species2, " (R=", cor.species2, ")"))

            comp.plot <- (ggplot(data = big.df, aes(x = sample1, y = sample2))
                          + xlab(paste0(expression(log2), " (ATPM+1) [", name1, "]"))
                          + ylab(paste0(expression(log2), " (ATPM+1) [", name2, "]"))
                          + geom_point(aes(col=species), alpha = 1, size = 2)
                          + facet_grid(~ species, labeller = ) + guides(col = F)
                          + theme_minimal() + plotCommonGrid + plotCommonTheme
                          + theme(axis.ticks.y = element_blank(),
                                  panel.grid.major = element_blank(),
                                  panel.border = element_rect(colour = "black", fill=NA, size=1)))

            return (comp.plot)
          })

---
title: "Dropbead tutorial"
author: "Nikos Karaiskos"
date: "13 Oct 2017"
output: html_document
---

```{r, echo=FALSE, include=FALSE}
library(dropbead)
library(data.table)
library(xlsx)
library(rJava)
library(xlsxjars)
library(Rsamtools)
reads.by.cell <- data.frame(fread('zcat < /mydaten/projects/hek3t3/data/ds_013_50fix/out_readcounts.txt.gz'))
dge.matrix=data.frame(fread("zcat < /mydaten/projects/hek3t3/data/ds_013_50fix/dge.txt.gz"), row.names = 1)
```

# Assess basic read and downstream statistics
## Extract read statistics
`Dropbead` provides two functions to readily extract useful statistics from the
data. The first one, `extractReadStatistics`, takes the BAM file as an argument
and computes the total number of (uniquely mapped) reads, the percentages
of intronic/intergenic etc. The output is a `data.frame` as follows:

```{r, echo=FALSE}
extractReadStatistics('/mydaten/projects/drosophila_brain/data/ds_032_WT_rep1/star_gene_exon_tagged_corrected.bam', yieldSize=10^6, sample.name='Drop-seq')
```

The read numbers are in million. The intronic, intergenic, coding and UTR reads
do not get a gene annotation tag (`GE:`) and are discarded from the Drop-seq
pipeline. The last column counts the total number of barcodes seen in the data,
most of them being artifacts from sequencing errors. 

## Knee plot and the number of cells
`Dropbead` provides a function to computationally estimate the number of cells
present in the sample, by calculating the inflection point of the cumulative
fraction of reads against the cell barcodes. Assuming that `reads.by.cell` 
is the `data.frame` with the reads per cell (the output of `BAMTagHistogram`
from the Drop-seq toolkit), 

```{r}
plotCumulativeFractionOfReads(reads.by.cell, 
                              cutoff = 10000, 
                              draw.infl.point = TRUE)
```

## Extract downstream statistics
The following function creates a table with the basic downstream statistics,
such as the cell number and the median number of reads, genes and UMIs per cell.

```{r}
extractDownstreamStatistics('~/dropseq-data/', min.umi=250, read.stats=NULL)
```

The total number of UMIs in the DGE is given in millions.
The PCR column provides the reads to UMIs ratio, so that the smaller, the better.
Passing the `data.frame` output of the `extractReadStatistics` function into
the `read.stats` argument provides a more precise calculation of the PCR
over-amplification bias.

# Mixed species experiments
Dropbead offers two main classes to store samples, the `SingleSpeciesSample` 
class and the `MixedSpeciesSample` class, the latter containing the former.

Mixed species experiments are important to estimate the number of doublets in 
the samples. Dropbead assumes that a digital gene expression matrix (DGE)
has already been generated and the genes for the two species are separated
by a prefix. For mixed human/mouse samples the prefixes are `hg_` and `mm_` 
respectively. Assuming that the DGE has been loaded in `dge.matrix`,

```{r}
# The object containing the sample
mms <- new("MixedSpeciesSample", 
           species1="human", 
           species2="mouse",
           dge=dge.matrix)
```

The number of cells and genes are stored and automatically updated while
using `dropbead`'s functions

```{r}
length(mms@cells) # number of cells in the sample
length(mms@genes) # number of genes detected
```

Some of the barcodes might correspond to the same cells (essentially after
using the `DetectBeadSynthesisErrors` Drop-seq tool) and have to be collapsed.
Such cells are identified by

```{r}
listCellsToCollapse(mms)
```

In the example above there are 5 pairs of cells which need to be collapsed.
This is straightforward with using

```{r}
mms <- collapseCellsByBarcode(mms)
```

We can verify that the number of cells is now the correct one

```{r}
length(mms@cells)
```

## Handling mixed species samples

Calling `classifyCellsAndDoublets` separates the species and returns a `data.frame` with 
number of transcripts per cell per species. The `threshold` controls the purity of the 
resulting cells, while `min.trans` is the minimum number of UMIs required to keep a cell.

```{r}
head(classifyCellsAndDoublets(mms, 
                              threshold = 0.9, 
                              min.trans = 1000))
```

The output of `classifyCellsAndDoublets` can be directly send for plotting

```{r, fig.width=10, fig.height=7.1}
plotCellTypes(classifyCellsAndDoublets(mms, threshold = 0.9, min.trans = 5000))
```

The number of genes per cell is computed via 

```{r}
head(computeGenesPerCell(mms))
```

and similarly for transcripts (UMIs) with the `computeTranscriptsPerCell` function.
Their output can be send directly for plotting and visualization

```{r}
plotViolin(computeTranscriptsPerCell(mms), 
           attribute = "UMIs")
plotHistogram(computeTranscriptsPerCell(mms), 
              attribute = 'UMIs')
```

The above functions are polymorphic and can be also used for `SingleSpeciesSample`
objects. Splitting the samples is always performed by internal functions automatically. 
If the user wants to restrict to only one species, this is done by the
`splitMixedSpeciesSampleToSingleSpecies` function. which returns a list of the two
`SingleSpeciesSample` objects.

```{r}
# Extracting the human cells as a separate sample for further analysis
h <- splitMixedSpeciesSampleToSingleSpecies(mms,
                                            threshold = 0.9)[[1]]
class(h)
```

# Single species

## Filtering functions
There are a couple of functions to remove low quality cells and genes, such as

```{r}
h.f1 <- keepBestCells(h, num.cells = 100) # keep only the top 100 cells
h.f2 <- keepBestCells(h, min.num.trans = 1000) # keep cells with at least 1000 UMIs
h.f3 <- removeLowQualityCells(h, min.genes = 2000) # remove cells which don't express at least 2000 genes
h.f4 <- removeLowQualityGenes(h, min.cells = 3) # remove genes which are not expressed in at least 3 cells
```

with obvious usage. 

## Comparing gene expression measurements
Reproducibility and correlations of different samples are easily assessed
via the `compareGeneExpressionLevels` function, for instance,

```{r}
compareGeneExpressionLevels(h.f2, h.f1, 
                            name1 = 'Drop-seq with >= 1000 UMIs per cell',
                            name2 = 'Drop-seq only 100 cells',
                            method = 'pearson')
```

If bulk data is available then its correlation pwith the Drop-seq sample is
directly assessed with the function `compareSingleCellsAgainstBulk`. Note that
bulk has to be in a 1-column `data.frame` format with genes as the `rownames`
and RPKM values (as default, raw counts are also accepted)

```{r}
compareSingleCellsAgainstBulk(h.f1, 
                              log2(h.f2@dge[, 1, drop=F]+1))
```

## Further exploration
It is instructive to assess the mitochondrial content of the single cell
samples. This is done as below and the percentages can be sent for plotting

```{r, warning = FALSE}
head(computeMitochondrialPercentage(h), 5)
plotMitochondrialContent(list(100-computeMitochondrialPercentage(h.f1),
                              100-computeMitochondrialPercentage(h.f3)),
                         log_scale = FALSE)
```

`Dropbead` offers also an implementation of the algorithm described in 
Macosko et. al. 2015 for classification of the cell cycle phases. The following
R-packages `xlsx`, `rJava` and `xlsxjars` are required for this

```{r}
phases <- assignCellCyclePhases(h)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{computeGenesPerCell}
\alias{computeGenesPerCell}
\title{Compute genes per cell}
\usage{
computeGenesPerCell(object, min.umis = 1, ...)
}
\arguments{
\item{object}{A \code{SingleSpeciesSample}.}

\item{min.umis}{The minimum number of UMIs to consider the gene as expressed (default is 1).}
}
\value{
A \code{data.frame} with cells, gene counts and species.
}
\description{
Computes the number of genes that a cell expresses.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotHistogram}
\alias{plotHistogram}
\title{Histogram plot of an attribute}
\usage{
plotHistogram(object, attribute = "ATTRIBUTE MISSING")
}
\arguments{
\item{object}{A \code{data.frame} such as the outputs of \code{computeGenesPerCell}
and \code{computeTranscriptsPerCell}.}

\item{attribute}{A \code{charracter string} describing the attribute.}
}
\description{
Histogram plot of an attribute
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\name{splitDgeByGenesAndCellsOfSpecies}
\alias{splitDgeByGenesAndCellsOfSpecies}
\title{Split DGE by genes and cells of species}
\usage{
splitDgeByGenesAndCellsOfSpecies(object, threshold = 0.9)
}
\arguments{
\item{object}{A \code{MixedSpeciesSample} object.}

\item{threshold}{The threshold which the ratio of transcripts of one species
over the other has to surpass in order to succesfully assign a cell to a species.}
}
\value{
A list \code{data.frames} representing the DGEs for each species.
}
\description{
Split DGE by genes and cells of species
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{removeCells}
\alias{removeCells}
\title{Remove cells by barcode}
\usage{
removeCells(object, cells)
}
\arguments{
\item{object}{A \code{data.frame} representing the DGE.}

\item{cells}{A character vector of cell barcodes to remove.}
}
\value{
The processed \code{data.frame} is returned.
}
\description{
Removes the provided cells from the sample.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{geneExpressionMean}
\alias{geneExpressionMean}
\title{Compute the average expression of each gene across all cells.}
\usage{
geneExpressionMean(object)
}
\arguments{
\item{object}{A \code{data.frame} representing DGE.}
}
\value{
A vector of mean expression values for each gene. Computation in log space.
}
\description{
Compute the average expression of each gene across all cells.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{computeTranscriptsPerCell}
\alias{computeTranscriptsPerCell}
\title{Compute transcripts per cell}
\usage{
computeTranscriptsPerCell(object, ...)
}
\arguments{
\item{object}{A Single species sample.}
}
\value{
A \code{data.frame} with cells, transcript counts and species.
}
\description{
Computes the number of transcripts (UMIs) that a cell contains.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tools.R
\name{findInflectionPoint}
\alias{findInflectionPoint}
\title{Compute the inflection point / cell number.}
\usage{
findInflectionPoint(object, max.cells = 10000, n = 1)
}
\arguments{
\item{object}{A vector containing the reads per cell as given by the Drop-seq
pipeline (BAMTagHistogram).}

\item{max.cells}{The number of cells to consider as an upper bound and to
compute the inflection point (default is 10000).}

\item{n}{The nubmer of inflection points to return (default is 1).}
}
\value{
The cell number.
}
\description{
Compute an inflection point (a.k.a. knee point, elbow of curve) of curve.
Can be used to compute the number of STAMPS that are present in the data
(see Drop-seq computational cookbook for further details).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\docType{methods}
\name{compareGeneExpressionLevels,MixedSpeciesSample-method}
\alias{compareGeneExpressionLevels,MixedSpeciesSample-method}
\title{Compare gene expression levels between two mixed species samples}
\usage{
\S4method{compareGeneExpressionLevels}{MixedSpeciesSample}(object1, object2,
  threshold1, threshold2, name1 = "sample1", name2 = "sample2")
}
\arguments{
\item{object1}{A \code{MixedSpeciesSample} object.}

\item{object2}{A \code{MixedSpeciesSample} object.}

\item{threshold1}{The threshold for the firs sample.}

\item{threshold2}{The threshold for the second sample.}
}
\value{
A plot comparing the gene expression levels by species.
}
\description{
Compare gene expression levels between two mixed species samples
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotHeatmapCorrelationMatrixDGE}
\alias{plotHeatmapCorrelationMatrixDGE}
\title{Heatmap of the correlation matrix for pairs of cells.}
\usage{
plotHeatmapCorrelationMatrixDGE(object)
}
\arguments{
\item{object}{A \code{data.frame} representing the DGE matrix.}
}
\description{
Heatmap of the correlation matrix for pairs of cells.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\docType{methods}
\name{listCellsToCollapse,MixedSpeciesSample-method}
\alias{listCellsToCollapse,MixedSpeciesSample-method}
\title{List cells that are candidates for collapsing.}
\usage{
\S4method{listCellsToCollapse}{MixedSpeciesSample}(object, threshold = 0.9)
}
\arguments{
\item{A}{\code{MixedSpeciesSample} object.}
}
\description{
Identify and list cells which share 11 bases in their barcodes and only the last
one is different. The cells are marked as candidates if and only if they're classified
as belonging to the same species.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{collapseCellsByBarcode}
\alias{collapseCellsByBarcode}
\title{Collapse cells by barcodes similarity}
\usage{
collapseCellsByBarcode(object, ...)
}
\arguments{
\item{object}{A \code{SingleSpeciesSample} object.}
}
\value{
A modified \code{SingleSpeciesSample} object.
}
\description{
Collapse cells which share 11 bases in their barcodes and only the last
one is different (usually being N, as a result of the DetectBeadSynthesisErrors
tool). The cells are marked as candidates if and only if they're classified
as belonging to the same species.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\name{splitDgeByGenesOfSpecies}
\alias{splitDgeByGenesOfSpecies}
\title{Split DGE by genes of species}
\usage{
splitDgeByGenesOfSpecies(object, prefix1 = NULL, prefix2 = NULL)
}
\arguments{
\item{object}{A \code{MixedSpeciesSample} object.}

\item{prefix1}{The prefix of the gene names for species1.}

\item{prefix2}{The prefix of the gene names for species2.}
}
\value{
A list of \code{data.frames} corresponding to the genes of the two species.
}
\description{
Splits the DGE of a \code{MixedSpeciesSample} into two \code{SingleSpeciesSample} DGEs.
The splitting is done by the prefixes of the gene names. If no prefixes are provided
the defaults are \code{hg_} for human and \code{mm_} for mouse respectively.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tools.R
\name{extractDownstreamStatistics}
\alias{extractDownstreamStatistics}
\title{Extract downstream statistics}
\usage{
extractDownstreamStatistics(object, dge.name = NULL, reads.by.cell = NULL,
  min.umi = 250, read.stats = NULL)
}
\arguments{
\item{object}{The exact location of the folder containing the analyzed data.}

\item{dge.name}{The file containing the DGE. If none is provided, the function assumes
that DGE is stored under the name \code{dge.txt.gz}.}

\item{reads.by.cell}{The \code{data.frame} containing the reads per cell. If none is
provided, the function tries to read the file \code{out_readcounts.txt.gz}.}

\item{min.umi}{The minimum number of UMIs to keep a cell and not discard it.}

\item{read.stats}{A \code{data.frame} containing read statistics, as it is produced
by the function \code{extractReadStatistics}.}
}
\description{
Extract downstream basic statistics such as cell number, median numger of reads,
genes, UMIs per cell. The \code{data.table} package is used for fast reading
of the DGE matrices.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{removeLowQualityGenes}
\alias{removeLowQualityGenes}
\title{Filter out low quality genes}
\usage{
removeLowQualityGenes(object, min.cells = 3)
}
\arguments{
\item{object}{A \code{data.frame} representing DGE.}

\item{n}{The minimum number of cells.}
}
\value{
A \code{data.frame} without the low quality genes.
}
\description{
Removes genes which are expressed in less than a minimum number of cells
(default is 3).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{removeLowQualityCells}
\alias{removeLowQualityCells}
\title{Filter out low quality cells}
\usage{
removeLowQualityCells(object, min.genes = 1000, ...)
}
\arguments{
\item{object}{A \code{data.frame} representing DGE.}

\item{n}{The minimum number of genes required.}
}
\value{
A \code{data.frame} without the low quality cells.
}
\description{
Removes cells expressing less than a minimum of genes (default value is 1000).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{geneExpressionSumUMI}
\alias{geneExpressionSumUMI}
\title{Compute the sum of transcript counts of each gene across all cells.}
\usage{
geneExpressionSumUMI(object)
}
\arguments{
\item{object}{A \code{data.frame} representing DGE.}
}
\value{
A vector of the logarithm of the sum of all UMI values for each gene.
A pseudocount is added to avoid infinities.
}
\description{
Compute the sum of transcript counts of each gene across all cells.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{keepBestCells}
\alias{keepBestCells}
\title{Keep best cells according to a criterion}
\usage{
keepBestCells(object, num.cells, min.num.trans = NULL)
}
\arguments{
\item{object}{A \code{data.frame} representing the DGE.}

\item{num.cells}{The number of cells to keep, ordered by total number of UMIs.}

\item{min.num.trans}{Keep only cells with at least this number of UMIs.}
}
\value{
The processed object.
}
\description{
Subsets the sample by keeping the top n cells, or the cells with a minimum number
of UMIs.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{computeMitochondrialPercentage}
\alias{computeMitochondrialPercentage}
\title{Computes mitochondrial percentage}
\usage{
computeMitochondrialPercentage(object, prefix = NULL)
}
\arguments{
\item{object}{A \code{SingleSpeciesSample} object.}

\item{prefix}{The prefix of mitochondrial genes.}
}
\value{
The percentage of mitochondrial encoded RNA UMIs.
}
\description{
Computes the percentageof UMIs coming from mitochondrial encoded RNA. For human,
mouse and melanogaster samples the mitochondrial prefix is hard-coded as \code{MT-},
\code{mt-} and \code{mt:} respectively. An alternative prefix can be also provided.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{assignCellCyclePhases}
\alias{assignCellCyclePhases}
\title{Cell cycle assignment}
\usage{
assignCellCyclePhases(object, gene.file = "~/Desktop/cell_cycle_genes.xlsx",
  do.plot = T, ...)
}
\arguments{
\item{object}{A human or mouse \code{SingleSpeciesSample}.}

\item{gene.file}{The excel sheet containing the cell cycle phase specific gene
markers. Taken from Macosko et al. 2015.}
}
\value{
A \code{data.frame} with cell cycle phase scores for every cell.
}
\description{
Assigns the cells into the 5 cell cycle phases, following the algorithm described
in Macosko et al. 2015. The table of genes is also taken from Macosko et al. 2015.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotCumulativeFractionOfReads}
\alias{plotCumulativeFractionOfReads}
\title{Plots the knee plot}
\usage{
plotCumulativeFractionOfReads(object, cutoff = 10000,
  draw.infl.point = TRUE)
}
\arguments{
\item{object}{A \code{data.frame} read from out_readcounts.txt.gz}

\item{cutoff}{The number of cells to take into account (default is 10000).}

\item{draw.infl.point}{Whether to annotate the inflation point or not.}
}
\description{
Plots the cumulative fraction of reads against cell barcodes (in descending
number of reads). This way provides a heuristic computation of the number of
STAMPS in the sample (see computational cookbook from Macosko et. al. 2015
for further details and reasoning).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SingleSpeciesSample.R
\name{compareGeneExpressionLevels}
\alias{compareGeneExpressionLevels}
\title{Compare gene expression levels between two single species samples}
\usage{
compareGeneExpressionLevels(object1, object2, name1 = "sample1",
  name2 = "sample2", col = "steelblue", method = "pearson", ...)
}
\arguments{
\item{object1}{A \code{SingleSpeciesSample} object.}

\item{object2}{A \code{SingleSpeciesSample} object.}

\item{name1}{The name of the first sample.}

\item{name2}{The name of the second sample.}

\item{method}{The method for computing the correlation.}
}
\value{
A plot comparing the gene expression levels.
}
\description{
Computes the averaged sums of the gene expression levels between two
samples, as well as their correlation.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\name{splitMixedSpeciesSampleToSingleSpecies}
\alias{splitMixedSpeciesSampleToSingleSpecies}
\title{Separate the mixed species sample into two single species samples}
\usage{
splitMixedSpeciesSampleToSingleSpecies(object, threshold = 0.9)
}
\arguments{
\item{object}{A \code{MixedSpeciesSample} object.}

\item{threshold}{The threshold which the ratio of transcripts of one species
over the other has to surpass in order to succesfully assign a cell to a species.}
}
\value{
A list of two \code{SingleSpeciesSample} objects.
}
\description{
Separate the mixed species sample into two single species samples
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{computeCorrelationSingleCellsVersusBulk}
\alias{computeCorrelationSingleCellsVersusBulk}
\title{Compare single cell sample against bulk data}
\usage{
computeCorrelationSingleCellsVersusBulk(single.cells, bulk.data,
  method = "pearson")
}
\arguments{
\item{single.cells}{The single cell object (could be a DGE or a
\code{SingleSpeciesSample} object).}

\item{bulk.data}{The bulk data formed as a \code{data.frame} with genes as
rownames and RPKM values as the first column.}

\item{method}{The method to compute the correlation (default is Pearson).}
}
\value{
A list of length 2. First item is the correlation and second is the
\code{data.frame}.
}
\description{
Computes correlation of gene expression measurements between a single cell
sample and bulk data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tools.R
\name{mergeMultipleDGEs}
\alias{mergeMultipleDGEs}
\title{Merge multiple samples into a big DGE matrix}
\usage{
mergeMultipleDGEs(object)
}
\arguments{
\item{object}{A \code{list} of DGEs.}
}
\value{
A \code{data.frame} containing all DGEs merged.
}
\description{
Merge the DGEs of multiple samples into a big one that can be used for
further analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotViolin}
\alias{plotViolin}
\title{Violin plot of an attribute}
\usage{
plotViolin(object, attribute = "ATTRIBUTE MISSING")
}
\arguments{
\item{object}{A \code{data.frame} such as the outputs of \code{computeGenesPerCell}
and \code{computeTranscriptsPerCell}.}

\item{attribute}{A \code{charracter string} describing the attribute.}
}
\description{
Violin plot of an attribute
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MixedSpeciesSample.R
\name{classifyCellsAndDoublets}
\alias{classifyCellsAndDoublets}
\title{Classify cells to species}
\usage{
classifyCellsAndDoublets(object, threshold = 0.9, min.trans = 500)
}
\arguments{
\item{object}{A \code{MixedSpeciesSample} object.}

\item{threshold}{The threshold which the ratio of transcripts of one species
over the other has to surpass in order to succesfully assign a cell to a species.
Below that threshold the cell is characterized as a doublet.}

\item{min.trans}{The minimum number of transcripts (UMIs) required for a cell.}
}
\value{
A \code{data.frame} containing the cell barcodes, the number of transcripts
per species and the characterization of the cell.
}
\description{
Classify the cells to species according to the transcripts they express.
The differentiation of species is performed internally and according to
the \code{species1} and \code{species2} labels of the sample. If the
classificiation is not confident enough, the cell is characterized as doublet.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Tools.R
\name{extractReadStatistics}
\alias{extractReadStatistics}
\title{Extract statistics from mapped reads.}
\usage{
extractReadStatistics(object, yieldSize = 10^6, sample.name = NULL)
}
\arguments{
\item{object}{A string describing the exact location of the BAM file for the
sample under consideration.}

\item{yieldSize}{Large BAM files are processed in batches because of memory
issues. The parameter \code{yieldSize} controls the batch size. Default value: 10^6.}

\item{sample.name}{A string describing the sample.}
}
\value{
A \code{data.frame} containing the computed statistics.
}
\description{
Extract statistics from mapped reads, such as total number of reads,
uniquely mapped reaqds, percentages of intronic/intergenic etc. The function
makes use of the R package Rsamtools (part of Bioconductor).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotCellTypes}
\alias{plotCellTypes}
\title{Plot separation of species}
\usage{
plotCellTypes(object)
}
\arguments{
\item{object}{A \code{data.frame} produced by the \code{classifyCellsAndDoublets}
function.}
}
\description{
Scatter plot of all cells by transcripts of species (a.k.a. barnyard plot). Species
and doublets are separated by different colors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DGEMatrix.R
\name{compareSingleCellsAgainstBulk}
\alias{compareSingleCellsAgainstBulk}
\title{Compare gene expression between single cell sample and bulk}
\usage{
compareSingleCellsAgainstBulk(single.cells, bulk.data, method = "pearson",
  ylab = "single cell sample", col = "steelblue", ...)
}
\arguments{
\item{single.cells}{A \code{data.frame} containing genes as rownames and columns as cells.}

\item{bulk.data}{A \code{data.frame} containing genes as rownames and a single column
with transcript counts.}

\item{ylab}{Label of the single cell sample.}

\item{col}{The color of the scatterplot points.}

\item{log.space}{If True (default value) then the average of single cells data is
performed in log space.}
}
\value{
A scatterplot comparing the gene expression levels and with the correlation
among the samples computed.
}
\description{
Compares the gene expression measurements from single cell data against bulk data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plottingMethods.R
\name{plotMitochondrialContent}
\alias{plotMitochondrialContent}
\title{Plot mitochondrial content}
\usage{
plotMitochondrialContent(object, log_scale = TRUE,
  sample_names = paste0("sample", 1:length(object)))
}
\arguments{
\item{object}{A list of mitochondrial content percentages, as computed by the
\code{ComputeMitochondrialContent} function.}

\item{log_scale}{Should the y-axis be in the log-scale?}

\item{sample_names}{The sample names}
}
\description{
Violin plots of mitochondrial content of one or more samples.
}
